<%--
    Document   : InviteMemberToProject.jsp
    Created on : Dec 15, 2008, 10:38:06 AM
    Author     : ksj, janh
    Updated by: jami (6.3.2012 - switch to Roles for Roles Assignment/PH Group Replacement),
--%>
<%@ include file="includes/jspheader.jsp"%>
<%@ include file="includes/jspencoding.jsp"%>
<%@ include file="includes/sdkinit.jsp"%>
<%@ include file="includes/sdklogincheck.jsp"%>

<%@ page import="java.util.*"%>
<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%@ page import="com.esko.webcenter.src.util.XMLUtils"%>
<%@ page import="com.esko.util.VectorUtils" %>
<%@ page import="com.esko.util.StringUtils" %>
<%@ page import="com.esko.webcenter.src.root.view.ProjectGroupMemberView"%>
<%@ page import="com.esko.webcenter.src.root.view.ProjectUserMemberView"%>
<%@ page import="com.esko.webcenter.src.xml.GroupXml" %>
<%@ page import="com.esko.webcenter.src.util.Xml" %>
<%@ page import="com.esko.webcenter.src.xml.UserXml" %>
<%@ page import="com.esko.webcenter.jsp.ProjDetailsUtils" %>
<%@ page import="com.eskographics.wc.ejb.InUseException"%>
<%@ page import="com.esko.webcenter.exceptions.InvalidApprovalRuleException"%>
<%@ page import="com.esko.webcenter.src.root.Permission"%>


<%
	// get the login
	String loginID = LoginMgr.getLoginMgr(session).getLoginID();

	// get parameters
	Properties requestParams = SDKUtils.getRequestParams(request, session,
			application, requestParamsLoginCheck);

	// get the project id/name, user id's and user names
	String projectID = (requestParams.containsKey("projectid")) ? ((String[]) requestParams.get("projectid"))[0] : null;
	String projectName = (requestParams.containsKey("projectname")) ? ((String[]) requestParams.get("projectname"))[0] : null;
	String[] userIDList = (requestParams.containsKey("usermemberid")) ? ((String[]) requestParams.get("usermemberid")) : null;
	String[] userNameList = (requestParams.containsKey("usermembername")) ? ((String[]) requestParams.get("usermembername")) : null;
	String[] groupIDList = (requestParams.containsKey("groupmemberid")) ? ((String[]) requestParams.get("groupmemberid")) : null;
	String[] groupNameList = (requestParams.containsKey("groupmembername")) ? ((String[]) requestParams.get("groupmembername")) : null;
	String folderId = (requestParams.containsKey("folderid")) ? ((String[]) requestParams.get("folderid"))[0] : null;
//	String[] projMemberIDList = (requestParams.containsKey("projectmemberid")) ? ((String[]) requestParams.get("projectmemberid")) : null;

	if ((projectID == null) && (projectName == null)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
		checkLogOff(session);
		return;
	}

	// DEPRECATED: placeholder groups functionality (now works as role assignment)
	String[] phGroupIDList = (requestParams.containsKey("placeholderid")) ? ((String[]) requestParams.get("placeholderid")) : null;
	String[] phGroupNameList = (requestParams.containsKey("placeholdername")) ? ((String[]) requestParams.get("placeholdername")) : null;
	if ((phGroupIDList != null) && (phGroupNameList != null)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Cannot mix placeholderid and placeholdername parameters."));
		checkLogOff(session);
		return;
	}

	// assign Project Roles functionality
	String[] roleIDList = (requestParams.containsKey("roleid")) ? ((String[]) requestParams.get("roleid")) : null;
	String[] roleNameList = (requestParams.containsKey("rolename")) ? ((String[]) requestParams.get("rolename")) : null;
	if ((roleIDList != null) && (roleNameList != null)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Cannot mix roleid and rolename parameters."));
		checkLogOff(session);
		return;
	}

	boolean viewMode = ((userIDList == null) && (userNameList == null) && (groupIDList == null) && 
			(groupNameList == null) && (roleIDList == null) && (roleNameList == null));

	// check a mix-up of the two sets of Role/Placeholder params
	if (((roleIDList != null) || (roleNameList != null)) && 
			((phGroupIDList != null) && (phGroupNameList != null))) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM,
						"Cannot mix [roleid/rolename] and [placeholderid/placeholdername] sets of parameters together."));
		checkLogOff(session);
		return;
	}

	// see if you are adding or removing users
	String approverString = (requestParams.containsKey("approver")) ? ((String[]) requestParams.get("approver"))[0] : null;
	String stageName = (requestParams.containsKey("stage")) ? ((String[]) requestParams.get("stage"))[0] : null;
	boolean addApprovers = (approverString != null) && approverString.trim().equals("1");
	boolean removeApprovers = (approverString != null) && approverString.trim().equals("0");
	String wholeGroupStr = (requestParams.containsKey("wholegroup")) ? ((String[]) requestParams.get("wholegroup"))[0] : null;
	short groupApprType = ComplexStageApprover.WHOLE_GROUP;
	int wholeGroup = 1;
	if ((wholeGroupStr != null) && wholeGroupStr.trim().equals("0")) wholeGroup = 0;

	String removeString = (requestParams.containsKey("remove")) ? ((String[]) requestParams.get("remove"))[0] : null;
	// Check if you are removing users from a project
	boolean removeMember = (removeString != null) && removeString.trim().equals("1");
	String ignoreMissingRoleStr = (requestParams.containsKey("ignoremissingrole")) ? ((String[]) requestParams.get("ignoremissingrole"))[0] : "";
	boolean ignoreMissingRole = !ignoreMissingRoleStr.trim().equals("0");   // default is "1"
	
	String debugString = (requestParams.containsKey("debug")) ? ((String[]) requestParams.get("debug"))[0] : null;
	boolean debug = (debugString != null) && debugString.trim().equals("1");

	Project project = null;
	// create the ejbs
	ProjectMgrTM projectMgrTM = DBTMUtils.findBean(response, session, ProjectMgrTM.class);
	ProjectTM projectTM = DBTMUtils.findBean(response, session, ProjectTM.class);
	UserTM userTM = DBTMUtils.findBean(response, session, UserTM.class);
	GroupTM groupTM = DBTMUtils.findBean(response, session, GroupTM.class);
	ComplexApprovalTM complexApprovalTM = DBTMUtils.findBean(response, session, ComplexApprovalTM.class);

	if ((projectTM == null) || (projectMgrTM == null) || (userTM == null) || 
			(groupTM == null) || (complexApprovalTM == null)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
		return;
	}

	// Container for list of members and approvers
	Vector<ProjectUserMemberView> existingUserMemberViews = null;
	Vector<ProjectGroupMemberView> existingGroupMemberViews = null;

	StringBuffer res = new StringBuffer();

	try {
		if (debug) res.append("<debug>" + Xml.NEWLINEPARAM);

		// try to find specified project in WCR database
		if (projectID != null) {
			project = projectTM.findById(loginID, projectID);
		}
		else {
			project = projectTM.findByName(loginID, projectName);
		}
		if (project == null) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PROJ_LOAD_FAILED,
					"Project not found. Check that the referenced project exists and the user has access to it"));
			checkLogOff(session);
			return;
		}
		projectID = project.getObjectID();

		//[WCR10.2] Check 'Cannot Change Inactive Project Mambers' security restriction setting
		if (ProjDetailsUtils.noInactiveProjectMembersChange(session, response, application, project)) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, "The processed Project (project id: "
					+ projectID + ") cannot have its Members changed as it is currently inactive."));
			checkLogOff(session);
			return;
		}

		if (!viewMode) {
			// get existing project members
			existingUserMemberViews = projectTM.loadUserMemberViews(loginID, project.getObjectID(), null, false);
			existingGroupMemberViews = projectTM.loadGroupMembersWithRoles(loginID, project.getObjectID(), null);
			if (debug) {
				res.append("<previous_user_members>" + Xml.NEWLINEPARAM);
				if (existingUserMemberViews != null) {
					for (int i = 0; i < existingUserMemberViews.size(); i++)
					{
						res.append("<user_member>");
						res.append("<id>" + existingUserMemberViews.get(i).getProjectUserMember().getUserMemberID() + "</id>" + Xml.NEWLINEPARAM);
						res.append("<member_id>" + existingUserMemberViews.get(i).getProjectUserMember().getObjectID() + "</member_id>" + Xml.NEWLINEPARAM);
						res.append("</user_member>" + Xml.NEWLINEPARAM);
					}
				}
				res.append("</previous_user_members>" + Xml.NEWLINEPARAM);
				
				res.append("<previous_group_members>" + Xml.NEWLINEPARAM);
				if (existingGroupMemberViews != null) {
					for (int i = 0; i < existingGroupMemberViews.size(); i++) {
						res.append("<group_member>" + Xml.NEWLINEPARAM);
						res.append("<id>" + existingGroupMemberViews.get(i).getProjectGroupMember().getGroupMemberID() + "</id>" + Xml.NEWLINEPARAM);
						res.append("<member_id>" + existingGroupMemberViews.get(i).getProjectGroupMember().getObjectID() + "</member_id>" + Xml.NEWLINEPARAM);
						res.append("</group_member>" + Xml.NEWLINEPARAM);
					}
				}
				res.append("</previous_group_members>" + Xml.NEWLINEPARAM);
			}

			// Get the ID's for the existing user and group project members
			Vector<String> existingUserMemberIDs = null;
			if (existingUserMemberViews != null) {
				existingUserMemberIDs = new Vector<String>(existingUserMemberViews.size());
				for (int i = 0; i < existingUserMemberViews.size(); i++) {
					existingUserMemberIDs.add(existingUserMemberViews.get(i).getProjectUserMember().getObjectID());
				}
			}
			Vector<String> existingGroupMemberIDs = null;
			if (existingGroupMemberViews != null) {
				existingGroupMemberIDs = new Vector<String>(existingGroupMemberViews.size());
				for (int i = 0; i < existingGroupMemberViews.size(); i++) {
					existingGroupMemberIDs.add(existingGroupMemberViews.get(i).getProjectGroupMember().getObjectID());
				}
			}

			// collect and verify all user IDs
			Vector<String> userIDs = new Vector<String>();

			if (userIDList != null) {
				for (int i = 0; i < userIDList.length; i++) {
					String userID = userIDList[i];
					// skip users that are already in the list of users to be added to group
					if ((userID.length() == 0) || userIDs.contains(userID)) continue;

					// verify user with specified ID exists in WCR database and is active
					User user = userTM.findById(loginID, userID);
					if (user != null && user.isLoaded() && !user.isDeleted() && user.isActiveUser()) {
						userIDs.add(userID);
					}
					else {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
						checkLogOff(session);
						return;
					}
				}
			}

			// collect and verify all Group ID's
			Vector<String> groupIDs = new Vector<String>();

			if (groupIDList != null) {
				for (int i = 0; i < groupIDList.length; i++) {
					String groupID = groupIDList[i];

					// skip users that are already in the list of users to be added to group
					if ((groupID.length() == 0) || groupIDs.contains(groupID)) continue;

					// verify user with specified ID exists in WCR database
					Group group = groupTM.findById(loginID, groupID);
					if (group != null) {
						groupIDs.add(groupID);
					}
					else {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP));
						checkLogOff(session);
						return;
					}
				}
			}

			// Collect and verify all user names, check user ID not already in list
			if (userNameList != null) {
				for (int i = 0; i < userNameList.length; i++) {
					String userName = userNameList[i];

					if ((userName == null) || userName.length() == 0) continue;

					// get user ID by given name
					User user = userTM.findUserByCompanyNameAndUserName(loginID, null, userName);
					if (user != null && user.isLoaded() && !user.isDeleted() && user.isActiveUser()) {
						String userID = user.getObjectID();
						// If user already in userIDs don't add him
						if (!userIDs.contains(userID)) userIDs.add(userID);
					}
					else {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
						checkLogOff(session);
						return;
					}
				}
			}

			// Collect and verify all group names, check group ID not already in list
			if (groupNameList != null) {
				for (int i = 0; i < groupNameList.length; i++) {
					String groupName = groupNameList[i];

					if ((groupName == null) || groupName.length() == 0) continue;

					// get group ID by given name
					Group group = groupTM.findGroupByName(loginID, groupName);
					if (group != null) {
						String groupID = group.getObjectID();

						// If group already in groupIDs don't add it
						if (!groupIDs.contains(groupID)) groupIDs.add(groupID);
					}
					else {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP));
						checkLogOff(session);
						return;
					}
				}
			}

			// ===============================
			// process roles
			
			// first check whether role(s) is(are) not specified
			Vector<Group> roles = new Vector<Group>();
			Vector<String> roleIDs = new Vector<String>();  // utility vector to keep track of the roles that are already added
			try {
				if (phGroupIDList != null) {
					for (int i = 0; i < phGroupIDList.length; i++) {
						Group role = groupTM.findById(loginID, phGroupIDList[i]);
						if (role != null && !roleIDs.contains(role.getObjectID()) ) {
							roles.add(role);
							roleIDs.add(role.getObjectID());
						}
					}
				}
				if (phGroupNameList != null) {
					// find IDs of groups specified by name
					for (int i = 0; i < phGroupNameList.length; i++) {
						Group role = groupTM.findRoleByName(loginID, phGroupNameList[i]);
						if (role != null && !roleIDs.contains(role.getObjectID()) ) {
							roles.add(role);
							roleIDs.add(role.getObjectID());
						}
					}
				}
				if (roleIDList != null) {
					for (int i = 0; i < roleIDList.length; i++) {
						Group role = groupTM.findById(loginID, roleIDList[i]);
						if (role == null) {
							if (!ignoreMissingRole) {
								if (roleIDList[i] == null) roleIDList[i] = "";
								out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_ROLE, "Role with ID '" + roleIDList[i] + "' doesn't exist.")); 
								checkLogOff(session);
								return;
							}
						}
						else {
							if (role != null && !roleIDs.contains(role.getObjectID()) ) {
								roles.add(role);
								roleIDs.add(role.getObjectID());
							}
						}
					}
				}
				if (roleNameList != null) {
					// find IDs of groups specified by name
					for (int i = 0; i < roleNameList.length; i++) {
						Group role = groupTM.findRoleByName(loginID, roleNameList[i]);
						if (role == null) {
							if (!ignoreMissingRole) {
								if (roleNameList[i] == null) roleNameList[i] = "";
								out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_ROLE, "Role with name '" + roleNameList[i] + "' doesn't exist.")); 
								checkLogOff(session);
								return;
							}
						}
						else {
							if (role != null && !roleIDs.contains(role.getObjectID()) ) {
								roles.add(role);
								roleIDs.add(role.getObjectID());
							}
						}
					}
				}
			}
			catch (WebCenterRemoteException remEx) {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP, remEx.getMessage())); 
				checkLogOff(session);
				return;
			}
			
			Vector<String> foundRoleIDs = new Vector<String>();
			
			if (roles.size() > 0) {
				// one or more roles specified - handle them first
				if (((userIDs.size() > 0) && (roles.size() != userIDs.size())) || 
						((groupIDs.size() > 0) && (roles.size() != groupIDs.size()))) {
					// users/groups should be invited -> roles will be assigned to them
					// check the number of users/groups is the same as roles
					// (verification that just users or just groups are specified was already done)
					out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM,
							"Specified role groups and assignment users/groups pairs do not correspond."));
					checkLogOff(session);
					return;
				}

				if ((userIDs.size() > 0) && (groupIDs.size() > 0)) {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, 
							"Users and groups cannot be assigned to roles at once. Please, split the assignment to two SDK calls."));
					checkLogOff(session);
					return;
				}

				// go through all existing project group members and try to find roles that matches roles
				// passed as parameters of the SDK call
				for (int i = 0; i < roles.size(); i++) {
					String roleID = roles.get(i).getObjectID();
					for (ProjectGroupMemberView pgmView : existingGroupMemberViews) {
						ProjectGroupMember pgm = pgmView.getProjectGroupMember();
						if (roleID.equals(pgm.getGroupMemberID())) {
							// (roles cannot be assigned to other roles)
							foundRoleIDs.add(roleID);
							break;
						}
					}
				}
			}

			Vector<ProjectUserMemberView> foundUserMemberViews = new Vector<ProjectUserMemberView>();
			Vector<String> foundUserMemberIDs = new Vector<String>();

			Vector<ProjectGroupMemberView> foundGroupMemberViews = new Vector<ProjectGroupMemberView>();
			Vector<String> foundGroupMemberIDs = new Vector<String>();

			// identify and store all already existing project members specified as <user/group> and
			// <user/group + role> by SDK call parameters
			
			if (userIDs.size() > 0) {
				// go through all existing project user members and try to find matches with SDK call input
				// (<user + role> pairs passed as parameters) -> foundUserMemberViews list is filled by the matches
				for (int i = 0; i < userIDs.size(); i++) {
					String userID = userIDs.get(i);
					String roleID = "";
					if (roles.size() > 0) roleID = roles.get(i).getObjectID();
					for (ProjectUserMemberView pumView : existingUserMemberViews) {
						ProjectUserMember pum = pumView.getProjectUserMember();
						if (userID.equals(pum.getUserMemberID()) && roleID.equals(pum.getRoleID())) {
							foundUserMemberViews.add(pumView);
							foundUserMemberIDs.add(pum.getObjectID());
							break;
						}
					}
				}
			}

			if (groupIDs.size() > 0) {
				// go through all existing project group members and try to find matches with SDK call input
				// (<group + role> pairs passed as parameters) -> foundGroupMemberViews list is filled by the matches
				for (int i = 0; i < groupIDs.size(); i++) {
					String groupID = groupIDs.get(i);
					String roleID = "";
					if (roles.size() > 0) roleID = roles.get(i).getObjectID();
					for (ProjectGroupMemberView pgmView : existingGroupMemberViews) {
						// skip project group members that are in fact roles - they are handled separately
						if (pgmView.getGroup().isRole()) continue;

						ProjectGroupMember pgm = pgmView.getProjectGroupMember();
						if (groupID.equals(pgm.getGroupMemberID()) && roleID.equals(pgm.getRoleID())) {
							foundGroupMemberViews.add(pgmView);
							foundGroupMemberIDs.add(pgm.getObjectID());
							break;
						}
					}
				}
			}
				
			//===========================================================
			// process the change request
			// ==========================================================

			// first add/remove members
			if ((roles.size() > 0) || (userIDs.size() > 0) || (groupIDs.size() > 0)) {
				try {
					if (debug) res.append("<actions>" + Xml.NEWLINEPARAM);

					boolean userMembersChanged = false;
					boolean groupMembersChanged = false;

					if (removeMember) {
						// remove found project user and group members from the project
						// start with users
						if (foundUserMemberViews.size() > 0) {
							if (debug) res.append("<action>Removing " + foundUserMemberViews.size() + " user members</action>" + Xml.NEWLINEPARAM);
							// perform the uninvitation
							projectMgrTM.uninviteMembersFromProject(loginID, project.getObjectID(), null, null, foundUserMemberViews, null);
							userMembersChanged = true;
						}

						// groups
						if (foundGroupMemberViews.size() > 0) {
							if (debug) res.append("<action>Removing " + foundGroupMemberViews.size() + " group members</action>" + Xml.NEWLINEPARAM);
							// perform the uninvitation
							projectMgrTM.uninviteMembersFromProject(loginID, project.getObjectID(), null, null, null, foundGroupMemberViews);
							groupMembersChanged = true;
						}
						
						// roles should be removed last, because it's not possible to remove a role still assigned to
						// a project user or group member
						// they are removed only when no users and/or groups are passed to be removed
						if ((foundRoleIDs.size() > 0) && (userIDs.size() == 0) && (groupIDs.size() == 0)) {
							if (debug) res.append("<action>Removing " + foundRoleIDs.size() + " role members</action>" + Xml.NEWLINEPARAM);
							try {
								// perform the uninvitation
								projectMgrTM.uninviteGroupsFromProject(loginID, project.getObjectID(), foundRoleIDs);
								groupMembersChanged = true;  // (roles are loaded together with groups)
							}
							catch (InUseException inUseEx) {
								out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, 
										"One or more roles to be removed from the project is still assigned to a project member."));
								checkLogOff(session);
								return;
							}
						}
					}
					else {
						// invite given users/groups/roles to project
						
						// start with roles to be invited as normal project members (groups)
						Vector<ProjectGroupMember> invitedRoles = new Vector<ProjectGroupMember>();
						
						Vector<String> newRoleIDs = Group.getGroupIDsFromVector(roles);
						// remove all already invited roles (optimization - it's not done for users and groups,
						// because it's much harder to implement...)
						newRoleIDs.removeAll(foundRoleIDs);
						// invite roles to project as groups (without any other roles assignments!)
						if (newRoleIDs.size() > 0) {
							invitedRoles.addAll(projectMgrTM.inviteGroupsToProject(loginID, project.getObjectID(), newRoleIDs, null));
						}
						if (invitedRoles.size() > 0) {
							if (debug) res.append("<action>Adding " + invitedRoles.size() + " role members</action>" + Xml.NEWLINEPARAM);
							groupMembersChanged = true;  // (roles are loaded together with groups)
						}
						
						// add specified users and groups [with roles] to project
						// inner logic will handle duplicities and already invited members automatically
						
						// users
						
						Hashtable<String, Vector<String>> newUsersByRoleTable = new Hashtable<String, Vector<String>>();
						Vector<ProjectUserMember> invitedUserMembers = new Vector<ProjectUserMember>();
						
						for (int i = 0; i < userIDs.size(); i++) {
							String userID = userIDs.get(i);
							String roleID = "";
							if (roles.size() > 0) roleID = roles.get(i).getObjectID();
							// (with and without roles in one go)
							if (newUsersByRoleTable.get(roleID) == null) {
								// initialize first entry for actual roleID
								newUsersByRoleTable.put(roleID, new Vector<String>());
							}
							newUsersByRoleTable.get(roleID).add(userID);
						}
					
					   Vector<HashMap<String, Permission>> permList = null;
					   if(folderId != null) {
							 //if folder Id is available set "View" permission only that folder
					  		 permList = projectMgrTM.restrictToSingleFolderViewPermission(loginID, project.getObjectID(), folderId);
							 if(Objects.equals(folderId,"0")){
								 permList.get(0).put(Permission.PROJECT,new Permission());
							 }
					   }
						
						Enumeration<String> keys = newUsersByRoleTable.keys();
						while (keys.hasMoreElements()) {
							String actRoleID = keys.nextElement();
							Vector<String> userIDsAssignedToRole = newUsersByRoleTable.get(actRoleID);
							if (actRoleID.length() == 0) {
								// special case - users invited to project without a role
								if (userIDsAssignedToRole != null) {
									// if folder permission is list available invite the user with folder permission list
									// if folder permission is not available, set permission list as null, implicit (default) permissions are granted to that user.
									permList = (permList != null && !permList.isEmpty()) ? permList : null;
									
									invitedUserMembers.addAll(projectMgrTM.inviteUsersToProject(loginID, project.getObjectID(), 
												userIDsAssignedToRole, permList));
								}
							}
							else {
								// invite users assigned to 'actRoleID' role to the project
								if (userIDsAssignedToRole != null) {
									invitedUserMembers.addAll(projectMgrTM.assignInviteNewUsersToProject(loginID, project.getObjectID(), 
											actRoleID, userIDsAssignedToRole, null));
								}
							}
						}
						if (invitedUserMembers.size() > 0) {
							if (debug) res.append("<action>Adding " + invitedUserMembers.size() + " user members</action>" + Xml.NEWLINEPARAM);
							userMembersChanged = true;
						}
						
						// groups
						
						Hashtable<String, Vector<String>> newGroupsByRoleTable = new Hashtable<String, Vector<String>>();
						Vector<ProjectGroupMember> invitedGroupMembers = new Vector<ProjectGroupMember>();
						
						for (int i = 0; i < groupIDs.size(); i++) {
							String groupID = groupIDs.get(i);
							String roleID = "";
							if (roles.size() > 0) roleID = roles.get(i).getObjectID();
							// (with and without roles in one go)
							if (newGroupsByRoleTable.get(roleID) == null) {
								// initialize first entry for actual roleID
								newGroupsByRoleTable.put(roleID, new Vector<String>());
							}
							newGroupsByRoleTable.get(roleID).add(groupID);
						}
						
						keys = newGroupsByRoleTable.keys();
						while (keys.hasMoreElements()) {
							String actRoleID = keys.nextElement();
							Vector<String> groupIDsAssignedToRole = newGroupsByRoleTable.get(actRoleID);
							if (actRoleID.length() == 0) {
								// special case - groups invited to project without a role
								if (groupIDsAssignedToRole != null) {
									invitedGroupMembers.addAll(projectMgrTM.inviteGroupsToProject(loginID, project.getObjectID(), 
											groupIDsAssignedToRole, null));
								}
							}
							else {
								// invite groups assigned to 'actRoleID' role to the project
								if (groupIDsAssignedToRole != null) {
									invitedGroupMembers.addAll(projectMgrTM.assignInviteNewGroupsToProject(loginID, project.getObjectID(), 
											actRoleID, groupIDsAssignedToRole, null));
								}
							}
						}
						if (invitedGroupMembers.size() > 0) {
							if (debug) res.append("<action>Adding " + invitedGroupMembers.size() + " group members</action>" + Xml.NEWLINEPARAM);
							groupMembersChanged = true;
						}
						
						// send out the 'Members Invited' notifications
						try 
						{	
							ProjectNotificationMgr notificationMgr = new ProjectNotificationMgr(response, session, request);
							notificationMgr.NotifyOnMemberInvitedToProject(loginID, projectID, ProjectUserMember.getUserIDs(invitedUserMembers), ProjectGroupMember.getGroupExtendedIDs(invitedGroupMembers));
						}
						catch (Exception ex) {
							//log the error, but do not fail the whole SDK request
							LogUtils.LogSDK(request, session, "InviteMemberToProject.jsp: Event notification on 'new member invitation' to Project with ID " + projectID + "failed. Details: " + ex.getMessage());
						}
					}

					// reload user and group project members to get accurate picture...
					if (userMembersChanged) {
						existingUserMemberViews = projectTM.loadUserMemberViews(loginID, project.getObjectID(), null, false);
						if (existingUserMemberViews != null) {
							existingUserMemberIDs = new Vector<String>(existingUserMemberViews.size());
							for (int i = 0; i < existingUserMemberViews.size(); i++) {
								existingUserMemberIDs.add(existingUserMemberViews.get(i).getProjectUserMember().getObjectID());
							}
						}
						else existingUserMemberIDs = null;
					}
					if (groupMembersChanged) {
						existingGroupMemberViews = projectTM.loadGroupMembersWithRoles(loginID, project.getObjectID(), null);
						if (existingGroupMemberViews != null) {
							existingGroupMemberIDs = new Vector<String>(existingGroupMemberViews.size());
							for (int i = 0; i < existingGroupMemberViews.size(); i++) {
								existingGroupMemberIDs.add(existingGroupMemberViews.get(i).getProjectGroupMember().getObjectID());
							}
						}
						else existingGroupMemberIDs = null;
					}

					
					// ====================================
					// add project approvers if requested
					
					if (addApprovers || removeApprovers) {
						// first check whether the approval setup is a staged approval and if so, whether 
						// the stage name is specified
						ComplexApprovalRule appRule = complexApprovalTM.loadApprovalSetup(loginID, project.getObjectID(), 
								null, null, null);
						
						// when there is no existing approval rule, initialize one 
						if (appRule == null) {
							appRule = new ComplexApprovalRule(1); // empty rule with one stage
							appRule.initialize(project.getObjectID(), null, null, null); // rule applies to the project
							ComplexApprovalStage stage = new ComplexApprovalStage();
							stage.initialize(null, "", 1);
							Vector<ComplexApprovalStage> stages = new Vector<ComplexApprovalStage>();
							stages.add(stage);
							appRule.setStages(stages);
						}

						// if the approval rule is staged, then the stagename has to be sepcified 
						if ((!appRule.isSimpleApproval()) && (stageName == null || stageName.length() == 0)) {
							// give an error, for staged approval, the name needs to be specified
							out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_APPR_STAGE));
							checkLogOff(session);
							return;
						}

						Vector<ComplexApprovalStage> stages = appRule.stages();

						boolean changedUserApprovers = false;
						boolean changedGroupApprovers = false;

						ComplexApprovalStage stage = null;
						int stageIndex = 0;
						String stageID = null;
						// load actual approvers (Approver class instances)
						Vector<ComplexStageApprover> projectApprovers = null;
						if ((stageName == null || stageName.length() == 0)) {
							// get the approvers of the single stage
							stage = stages.elementAt(0);
							projectApprovers = stage.approvers();
							stageID = stage.getObjectID();
						}
						else {
							// find the stage with the specified name 
							for (int i = 0; i < stages.size(); i++) {
								stage = stages.elementAt(i);
								if (stageName.equalsIgnoreCase(stage.name())) {
									projectApprovers = stage.approvers();
									stageID = stage.getObjectID();
									stageIndex = i;
								}
							}
						}

						boolean isApproversChanged = false;

						Vector<ComplexStageApprover> newApprovers = new Vector<ComplexStageApprover>();
						if (removeApprovers) {
							// take out the user and group approvers
							isApproversChanged = removeApproversFromList(projectApprovers, userIDs, groupIDs);
						}

						if (addApprovers) {
							// add the new users/groups/roles to the list of approvers 
							isApproversChanged = isApproversChanged || addApproversToList(projectApprovers, userIDs, groupIDs, wholeGroup, stageID);
						}
						if (isApproversChanged) {
							try {
								// check the approval setup to be saved is valid:
								// - there is no stages with the same name and 
								// - each stage has at least one approver
								appRule.checkValidApprovalRule();
							}
							catch (InvalidApprovalRuleException invalidApprEx) {
								// cannot save an invalid approval setup to DB
								out.write(SDKUtils.ShowError(SDKUtils.SDK_APPR_ACTION_FAILED, invalidApprEx.getMessage()));
								checkLogOff(session);
								return;
							}
						
							// ... and save if any (real) change done
							complexApprovalTM.saveApprovalSetup(loginID, appRule);
						}
					}
				}
				finally {
					if (debug) res.append("</actions>" + Xml.NEWLINEPARAM);
				}
			}
		}
		else {
			// view mode = no changes just print out current project members and approvers
			// project members
			existingUserMemberViews = projectTM.loadUserMemberViews(loginID, project.getObjectID(), null, false);
			existingGroupMemberViews = projectTM.loadGroupMembersWithRoles(loginID, project.getObjectID(), null);
		}

		// generate the output (added members' IDs)
		// unless in debug mode, no elments should have been written to out before this point
		res.append("<result>" + Xml.NEWLINEPARAM);
		res.append("<project_id>" + project.getObjectID() + "</project_id>" + Xml.NEWLINEPARAM);
		res.append("<user_members>" + Xml.NEWLINEPARAM);
		if (existingUserMemberViews != null) {
			// get the complete list of users after update
			for (int i = 0; i < existingUserMemberViews.size(); i++) {
				User usr = existingUserMemberViews.get(i).getUserView().getUser();
				ProjectUserMember projMember = existingUserMemberViews.get(i).getProjectUserMember();
				
				res.append("<user_member>" + Xml.NEWLINEPARAM);
				res.append("<id>" + usr.getObjectID() + "</id>" + Xml.NEWLINEPARAM);
				res.append("<project_member_id>" + projMember.getObjectID() + "</project_member_id>" + Xml.NEWLINEPARAM);
				res.append("<username>" + XMLUtils.safeEncodeXml(usr.getName()) + "</username>" + Xml.NEWLINEPARAM);
				res.append("<first_name>" + XMLUtils.safeEncodeXml(usr.getFirstName()) + "</first_name>" + Xml.NEWLINEPARAM);
				res.append("<last_name>" + XMLUtils.safeEncodeXml(usr.getLastName()) + "</last_name>" + Xml.NEWLINEPARAM);
				if (projMember.getRoleID().length() > 0) {
					res.append("<role_id>" + projMember.getRoleID() + "</role_id>" + Xml.NEWLINEPARAM);
					
					if(null != existingUserMemberViews.get(i).getRoleGroup()) {
						res.append("<role_name>" + XMLUtils.safeEncodeXml(existingUserMemberViews.get(i).getRoleGroup().getName()) + "</role_name>" + Xml.NEWLINEPARAM);
					}
				}
				res.append("</user_member>" + Xml.NEWLINEPARAM);
			}
		}
		res.append("</user_members>" + Xml.NEWLINEPARAM);
		res.append("<group_members>" + Xml.NEWLINEPARAM);
		if (existingGroupMemberViews != null) {
			// get the complete list of groups after update
			for (int i = 0; i < existingGroupMemberViews.size(); i++) {
				Group grp = existingGroupMemberViews.get(i).getGroup();
				ProjectGroupMember projMember = existingGroupMemberViews.get(i).getProjectGroupMember();
				
				res.append("<group_member>" + Xml.NEWLINEPARAM);
				res.append("<id>" + grp.getObjectID() + "</id>" + Xml.NEWLINEPARAM);
				res.append("<project_member_id>" + projMember.getObjectID() + "</project_member_id>" + Xml.NEWLINEPARAM);
				res.append("<name>" + XMLUtils.safeEncodeXml(grp.getName()) + "</name>" + Xml.NEWLINEPARAM);
				if (projMember.getRoleID().length() > 0) {
					res.append("<role_id>" + projMember.getRoleID() + "</role_id>" + Xml.NEWLINEPARAM);
					
					if(!(grp.isIsRoleSet() && grp.isRole()) && null != existingGroupMemberViews.get(i).getRoleGroup()) {
						res.append("<role_name>" + XMLUtils.safeEncodeXml(existingGroupMemberViews.get(i).getRoleGroup().getName()) + "</role_name>" + Xml.NEWLINEPARAM);
					}
				}
				res.append("<is_role>" + ((grp.isIsRoleSet() && grp.isRole()) ? "1" : "0") + "</is_role>" + Xml.NEWLINEPARAM);
				res.append("</group_member>" + Xml.NEWLINEPARAM);
			}
		}
		res.append("</group_members>" + Xml.NEWLINEPARAM);

		// load the approval rule and write the stages to the output
		ComplexApprovalRule appRule = complexApprovalTM.loadApprovalSetup(loginID, project.getObjectID(), null, null, null);
		if (appRule != null) {
			Vector<ComplexApprovalStage> stages = appRule.stages();

			//JANH TODO once implemented replace this with the real SDKUtils.writeStagesToXML() method!!!

			// write the stages to XML 
			//			res.append(SDKUtils.writeStagesToXML(appRule) + Xml.NEWLINEPARAM);
			res.append("<stages>" + Xml.NEWLINEPARAM);
			for (int i = 0; i < stages.size(); i++) {
				ComplexApprovalStage stage = stages.elementAt(i);
				res.append("<stage>" + XMLUtils.safeEncodeXml(stage.name())
						+ "</stage>");
			}
			res.append("</stages>" + Xml.NEWLINEPARAM);

			// for all stages, write the approvers to XML
			// do in two iterations, once to write all the users,
			// once to write the groups
			boolean firstuser = true;
			for (int i = 0; i < stages.size(); i++) {
				// get the stage and write the user approvers 
				ComplexApprovalStage stage = stages.elementAt(i);
				Vector<ComplexStageApprover> approvers = stage.approvers();

				int stageIndex = stage.counter();
				if (appRule.isSimpleApproval()) // when the rule is a simple app rule, do not write stage info
				stageIndex = 0;

				if (approvers != null) {
					for (int j = 0; j < approvers.size(); j++) {
						ComplexStageApprover approver = approvers.elementAt(j);
						// check whether this is a user, if so, write out 
						if (approver.approverType() == ComplexStageApprover.USER) {
							if (firstuser) {
								res.append("<user_approvers>" + Xml.NEWLINEPARAM);
								firstuser = false;
							}
							res.append(approverDetails(loginID, approver.approverUserID(), userTM, stageIndex));
						}
					}
				}
			}
			if (!firstuser) res.append("</user_approvers>" + Xml.NEWLINEPARAM);

			// write out the group approvers	
			boolean firstgroup = true;
			for (int i = 0; i < stages.size(); i++) {
				// get the stage and write the user approvers 
				ComplexApprovalStage stage = (ComplexApprovalStage)stages.elementAt(i);
				Vector<ComplexStageApprover> approvers = stage.approvers();
				int stageIndex = stage.counter();
				if (appRule.isSimpleApproval()) // when the rule is a simple app rule, do not write stage info
				stageIndex = 0;

				if (approvers != null) {
					for (int j = 0; j < approvers.size(); j++) {
						ComplexStageApprover approver = approvers.elementAt(j);
						// check whether this is a group, if so, write out 
						if (approver.approverType() != ComplexStageApprover.USER) {
							if (firstgroup) {
								res.append("<group_approvers>" + Xml.NEWLINEPARAM);
								firstgroup = false;
							}
							res.append(approverDetails(loginID, approver.approverGroupID(), approver.approverType(),
									groupTM, stageIndex));
						}
					}
				}
			}
			if (!firstgroup) res.append("</group_approvers>" + Xml.NEWLINEPARAM);
		}

		if (debug) res.append("<version>" + SDKUtils.getVersionString() + "</version>" + Xml.NEWLINEPARAM);

		res.append("</result>" + Xml.NEWLINEPARAM);

		if (debug) res.append("</debug>" + Xml.NEWLINEPARAM);
	}
	catch (WebCenterRemoteException ex) {
		ex.printStackTrace();
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
		checkLogOff(session);
		return;
	}
	catch (Throwable t) {
		t.printStackTrace();
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, t.getMessage()));
		checkLogOff(session);
		return;
	}

	out.write(res.toString());
	checkLogOff(session);
%>


<%!// remove the users/groups from the list of approvers 
	private boolean existApprover(Vector<ComplexStageApprover> projectApprovers, String approverID,
			boolean isUser)
	{
		if (projectApprovers != null) {
			for (int i = 0; i < projectApprovers.size(); i++) {
				ComplexStageApprover approver = projectApprovers.elementAt(i);
	
				// check whether it is a user type 
				if (isUser && approver.approverType() == ComplexStageApprover.USER)
				{
					if (approverID.equalsIgnoreCase(approver.approverUserID())) return true;
				}
				else if (!isUser && approver.approverType() != ComplexStageApprover.USER) {
					if (approverID.equalsIgnoreCase(approver.approverGroupID())) return true;
				}
			}
		}
		return false;
	}%>

<%!// add users/groups/roles to the list of approvers 
	private boolean addApproversToList(Vector<ComplexStageApprover> projectApprovers, Vector<String> userIDs,
			Vector<String> groupIDs, int wholeGroup, String stageID)
	{

		boolean modified = false;

		// add the users 
		if (userIDs != null) {
			for (int i = 0; i < userIDs.size(); i++) {
				// exist approver?
				boolean isUser = true;

				if (!existApprover(projectApprovers, (String) userIDs.elementAt(i), isUser)) {
					ComplexStageApprover approver = new ComplexStageApprover();
					approver.initialize(stageID, (String) userIDs.elementAt(i));
					projectApprovers.add(approver);
					modified = true;
				}
			}
		}

		// add the groups (and roles)
		if (groupIDs != null) {
			int appType = ComplexStageApprover.WHOLE_GROUP;
			if (wholeGroup == 0) appType = ComplexStageApprover.ONE_OF_GROUP;

			for (int i = 0; i < groupIDs.size(); i++) {
				// exist approver?
				boolean isUser = false;

				if (!existApprover(projectApprovers, (String) groupIDs.elementAt(i), isUser)) {
					ComplexStageApprover approver = new ComplexStageApprover();
					approver.initialize(stageID, null, (String) groupIDs.elementAt(i), appType);
					projectApprovers.add(approver);
					modified = true;
				}
			}
		}
		return modified;
	}%>

<%!// write information about the user in the XML file
	private String approverDetails(String loginID, String userID, UserTM userTM,
			int stageIndex) throws WebCenterRemoteException
	{
		// fetch the user and write the details in XML 
		StringBuffer userInfo = new StringBuffer();

		User apr = userTM.findById(loginID, userID);

		userInfo.append("<user_approver>" + Xml.NEWLINEPARAM);
		userInfo.append("<id>" + apr.getObjectID() + "</id>" + Xml.NEWLINEPARAM);
		if (stageIndex > 0) userInfo.append("<stage_index>" + stageIndex
				+ "</stage_index>" + Xml.NEWLINEPARAM);
		userInfo.append("<username>" + XMLUtils.safeEncodeXml(apr.getName())
				+ "</username>" + Xml.NEWLINEPARAM);
		userInfo.append("<first_name>" + XMLUtils.safeEncodeXml(apr.getFirstName())
				+ "</first_name>" + Xml.NEWLINEPARAM);
		userInfo.append("<last_name>" + XMLUtils.safeEncodeXml(apr.getLastName())
				+ "</last_name>" + Xml.NEWLINEPARAM);
		if (stageIndex > 0) userInfo.append("<stage_index>" + stageIndex
				+ "</stage_index>" + Xml.NEWLINEPARAM);
		userInfo.append("<type>" + ComplexStageApprover.USER + "</type>" + Xml.NEWLINEPARAM);
		userInfo.append("</user_approver>" + Xml.NEWLINEPARAM);

		return userInfo.toString();
	}%>

<%!// write information about the group/role in the XML file
	private String approverDetails(String loginID, String groupID, int appType,
			GroupTM groupTM, int stageIndex) throws WebCenterRemoteException

	{
		// fetch the group and write the details in XML 
		StringBuffer groupInfo = new StringBuffer();

		Group apr = groupTM.findById(loginID, groupID);

		groupInfo.append("<group_approver>" + Xml.NEWLINEPARAM);
		groupInfo.append("<id>" + apr.getObjectID() + "</id>" + Xml.NEWLINEPARAM);
		groupInfo.append("<name>" + XMLUtils.safeEncodeXml(apr.getName()) + "</name>" + Xml.NEWLINEPARAM);
 		if (stageIndex > 0) groupInfo.append("<stage_index>" + stageIndex
 				+ "</stage_index>" + Xml.NEWLINEPARAM);
		groupInfo.append("<type>" + appType + "</type>" + Xml.NEWLINEPARAM);
		groupInfo.append("<is_role>" + ((apr.isIsRoleSet() && apr.isRole()) ? "1" : "0") + "</is_role>" + Xml.NEWLINEPARAM);
		groupInfo.append("</group_approver>" + Xml.NEWLINEPARAM);

		return groupInfo.toString();
	}%>


<%!
	// remove the users/groups from the list of approvers 
	private boolean removeApproversFromList(Vector<ComplexStageApprover> projectApprovers,
			Vector<String> existingUserApproverIDs, Vector<String> existingGroupApproverIDs)
	{
		boolean listChanged = false;

		// iterate over the users and remove them when they are in the list
		if (existingUserApproverIDs != null) {
			for (int i = 0; i < existingUserApproverIDs.size(); i++) {
				String userID = (String) existingUserApproverIDs.elementAt(i);
				for (int j = 0; j < projectApprovers.size(); j++) {
					ComplexStageApprover cApprover = (ComplexStageApprover)projectApprovers.elementAt(j);
					if (cApprover.approverType() == ComplexStageApprover.USER) {
						String approverID = cApprover.approverUserID();
						if (userID.equalsIgnoreCase(approverID)) {
							projectApprovers.removeElementAt(j);
							listChanged = true;
							break;
						}
					}
				}
			}
		}

		// iterate over the groups (and roles) and remove them when they are in the list
		if (existingGroupApproverIDs != null) {
			for (int i = 0; i < existingGroupApproverIDs.size(); i++) {
				String groupID = (String) existingGroupApproverIDs.elementAt(i);
				for (int j = 0; j < projectApprovers.size(); j++) {
					ComplexStageApprover cApprover = (ComplexStageApprover) projectApprovers
							.elementAt(j);
					if (cApprover.approverType() != ComplexStageApprover.USER) {
						String approverID = cApprover.approverGroupID();
						if (groupID.equalsIgnoreCase(approverID)) {
							projectApprovers.removeElementAt(j);
							listChanged = true;
							break;
						}
					}
				}
			}
		}
		return listChanged;
	}
%>
